/*----------------------------------------------------------------*/
/*								  */
/*  Example of sqlcbv(): Clear Bind Variables  			  */
/*								  */
/*								  */
/*----------------------------------------------------------------*/

#include "stdio.h"
#include "sql.h"
#include "errsql.h"

/* error defines */
#define APIERROR    1

#define apierr(a) error(a,__LINE__, APIERROR)
  
	  SQLTRCD  rcd;				/* return code		  */
  	  SQLTCUR  cur;				/* SQLBASE cursor number  */
	
	  main()
{
	  SQLTROW   rows;		/* number of rows	  */
	  int	    count;	

static	  char	    create [] = 	/* CREATE TABLE statement */
"CREATE TABLE TEST (NO NUMBER NOT NULL)";
static	  char	    insert [] = 	/* INSERT statement	  */
"INSERT INTO TEST VALUES (:1)";
static	  char	    dbnam[] = "omed";	/* database name		    */

  /* CONNECT TO THE DATABASE */

  if (rcd = sqlcnc(&cur, dbnam, 0))	/* perform connect operation	    */
    apierr("SQLCNC");

  /* CREATE THE TABLE */
  if (rcd = sqlcex(cur, create, 0))	/* failure on compile and execute?  */
    apierr("SQLCEX");

  if (rcd = sqlgnr(cur, "TEST", 0, &rows)) /* get number of rows	    */
    apierr("SQLGNR");

  count = rows + 1;			

  /* COMPILE INSERT STATEMENT */
  if (rcd = sqlcom(cur, insert, 0))
    apierr("SQLCOM");

  /* BIND BY NUMBER */
  if (rcd = sqlbnn(cur, 1, (SQLTDAP)&count, sizeof(count), 0, SQLPUIN))
    apierr("SQLBNN");

  /* CLEAR BIND VARIABLES */
  if (rcd = sqlcbv(cur))
    apierr("SQLCBV");
  else
    printf("Cleared Bind Varaiables \n");
  
  /* EXECUTE INSERT STATEMENT */
  if (rcd = sqlexe(cur))
    apierr("SQLEXE");
  else
    printf("NUMBER %d SUCCESSFULLY INSERTED\n",count);
  
  /* BIND BY NUMBER */
  if (rcd = sqlbnn(cur, 1, (SQLTDAP)&count, sizeof(count), 0, SQLPUIN))
    apierr("SQLBNN");

  /* EXECUTE INSERT STATEMENT */
  if (rcd = sqlexe(cur))
    apierr("SQLEXE");
  else
    printf("NUMBER %d SUCCESSFULLY INSERTED\n",count);


  /*
    DISCONNECT FROM THE DATABASE
  */

  if (rcd = sqldis(cur))		/* failure on disconnect?	    */
    apierr("SQLDIS");
 
}

/*
  ERROR - prints an error message for the utility
*/
	  error(what, line, type)
	  char*     what;		/* description of what happened     */
	  int	    line;		/* line number where error occured  */
	  int	    type;		/* type of error		    */
  {
	  char	    msg[200];		/* error message buffer 	    */

      sqlerr(rcd, msg); 		  /* get the error message	    */
      printf("\nError: %s at line %d: %s, Error # %d\n", what, line, msg,rcd);
  }


